import arcade

_KEY_MAPPING = {
    "left": arcade.key.LEFT,
    "right": arcade.key.RIGHT,
    "up": arcade.key.UP,
    "down": arcade.key.DOWN,
    "a": arcade.key.A,
    "b": arcade.key.B,
    "c": arcade.key.C,
    "d": arcade.key.D,
    "e": arcade.key.E,
    "f": arcade.key.F,
    "g": arcade.key.G,
    "h": arcade.key.H,
    "i": arcade.key.I,
    "j": arcade.key.J,
    "k": arcade.key.K,
    "l": arcade.key.L,
    "m": arcade.key.M,
    "n": arcade.key.N,
    "o": arcade.key.O,
    "p": arcade.key.P,
    "q": arcade.key.Q,
    "r": arcade.key.R,
    "s": arcade.key.S,
    "t": arcade.key.T,
    "u": arcade.key.U,
    "v": arcade.key.V,
    "w": arcade.key.W,
    "x": arcade.key.X,
    "y": arcade.key.Y,
    "z": arcade.key.Z,
    "0": arcade.key.KEY_0,
    "1": arcade.key.KEY_1,
    "2": arcade.key.KEY_2,
    "3": arcade.key.KEY_3,
    "4": arcade.key.KEY_4,
    "5": arcade.key.KEY_5,
    "6": arcade.key.KEY_6,
    "7": arcade.key.KEY_7,
    "8": arcade.key.KEY_8,
    "9": arcade.key.KEY_9,
    "f1": arcade.key.F1,
    "f2": arcade.key.F2,
    "f3": arcade.key.F3,
    "f4": arcade.key.F4,
    "f5": arcade.key.F5,
    "f6": arcade.key.F6,
    "f7": arcade.key.F7,
    "f8": arcade.key.F8,
    "f9": arcade.key.F9,
    "f10": arcade.key.F10,
    "f11": arcade.key.F11,
    "f12": arcade.key.F12,
    "space": arcade.key.SPACE,
    "enter": arcade.key.ENTER,
    "return": arcade.key.RETURN,
    "esc": arcade.key.ESCAPE,
    "backspace": arcade.key.BACKSPACE,
    "tab": arcade.key.TAB,
    "shift": arcade.key.LSHIFT,
    "ctrl": arcade.key.LCTRL,
    "alt": arcade.key.LALT,
    "delete": arcade.key.DELETE,
    "pageup": arcade.key.PAGEUP,
    "pagedown": arcade.key.PAGEDOWN,
    "home": arcade.key.HOME,
    "end": arcade.key.END,
    "insert": arcade.key.INSERT
}

_KEY_MAPPING_REVERSE = {value: key for key, value in _KEY_MAPPING.items()}

_IMAGES_NAMES = ('plane', 'apple', 'knife', 'knife_bg', 'wood', 'ham_bg', 'ham', 'dog', 'cheese', 'huanhuan', 'plat_normal',
                 'shoot_bg', 'target', 'cursor', 'plane_bg', 'plane_red', 'plane_ground', 'rock', 'rock2', 'star')
_MAPS_NAMES = ('map_1', )

_IMAGES_MAPPING = {'playerShip2_orange': ':resources:images/space_shooter/playerShip2_orange.png',
                   'laserBlue01': ':resources:images/space_shooter/laserBlue01.png',
                   'meteorGrey_small1': ':resources:images/space_shooter/meteorGrey_small1.png',
                   'playerShip1_green': ':resources:images/space_shooter/playerShip1_green.png',
                   'meteorGrey_small2': ':resources:images/space_shooter/meteorGrey_small2.png',
                   'playerLife1_orange': ':resources:images/space_shooter/playerLife1_orange.png',
                   'meteorGrey_med2': ':resources:images/space_shooter/meteorGrey_med2.png',
                   'playerShip1_blue': ':resources:images/space_shooter/playerShip1_blue.png',
                   'meteorGrey_med1': ':resources:images/space_shooter/meteorGrey_med1.png',
                   'playerLife1_blue': ':resources:images/space_shooter/playerLife1_blue.png',
                   'playerShip3_orange': ':resources:images/space_shooter/playerShip3_orange.png',
                   'meteorGrey_big2': ':resources:images/space_shooter/meteorGrey_big2.png',
                   'meteorGrey_big3': ':resources:images/space_shooter/meteorGrey_big3.png',
                   'meteorGrey_big1': ':resources:images/space_shooter/meteorGrey_big1.png',
                   'meteorGrey_tiny2': ':resources:images/space_shooter/meteorGrey_tiny2.png',
                   'meteorGrey_big4': ':resources:images/space_shooter/meteorGrey_big4.png',
                   'meteorGrey_tiny1': ':resources:images/space_shooter/meteorGrey_tiny1.png',
                   'playerShip1_orange': ':resources:images/space_shooter/playerShip1_orange.png',
                   'laserRed01': ':resources:images/space_shooter/laserRed01.png',
                   'playerLife1_green': ':resources:images/space_shooter/playerLife1_green.png',
                   'back-buildings': ':resources:images/cybercity_background/back-buildings.png',
                   'far-buildings': ':resources:images/cybercity_background/far-buildings.png',
                   'foreground': ':resources:images/cybercity_background/foreground.png',
                   'cardBack_green1': ':resources:images/cards/cardBack_green1.png',
                   'cardBack_green3': ':resources:images/cards/cardBack_green3.png',
                   'cardBack_green2': ':resources:images/cards/cardBack_green2.png',
                   'cardClubs10': ':resources:images/cards/cardClubs10.png',
                   'cardBack_green5': ':resources:images/cards/cardBack_green5.png',
                   'cardBack_green4': ':resources:images/cards/cardBack_green4.png',
                   'cardClubs6': ':resources:images/cards/cardClubs6.png',
                   'cardHeartsK': ':resources:images/cards/cardHeartsK.png',
                   'cardHeartsJ': ':resources:images/cards/cardHeartsJ.png',
                   'cardClubs7': ':resources:images/cards/cardClubs7.png',
                   'cardClubsA': ':resources:images/cards/cardClubsA.png',
                   'cardClubs5': ':resources:images/cards/cardClubs5.png',
                   'cardSpadesJ': ':resources:images/cards/cardSpadesJ.png',
                   'cardDiamonds8': ':resources:images/cards/cardDiamonds8.png',
                   'cardBack_blue5': ':resources:images/cards/cardBack_blue5.png',
                   'cardBack_blue4': ':resources:images/cards/cardBack_blue4.png',
                   'cardSpades10': ':resources:images/cards/cardSpades10.png',
                   'cardDiamonds9': ':resources:images/cards/cardDiamonds9.png',
                   'cardSpadesK': ':resources:images/cards/cardSpadesK.png',
                   'cardClubs4': ':resources:images/cards/cardClubs4.png',
                   'cardClubsQ': ':resources:images/cards/cardClubsQ.png',
                   'cardSpades9': ':resources:images/cards/cardSpades9.png',
                   'cardDiamondsK': ':resources:images/cards/cardDiamondsK.png',
                   'cardBack_blue1': ':resources:images/cards/cardBack_blue1.png',
                   'cardDiamondsJ': ':resources:images/cards/cardDiamondsJ.png',
                   'cardSpades8': ':resources:images/cards/cardSpades8.png',
                   'cardClubs3': ':resources:images/cards/cardClubs3.png',
                   'cardHearts8': ':resources:images/cards/cardHearts8.png',
                   'cardDiamonds10': ':resources:images/cards/cardDiamonds10.png',
                   'cardBack_blue3': ':resources:images/cards/cardBack_blue3.png',
                   'cardBack_blue2': ':resources:images/cards/cardBack_blue2.png',
                   'cardHearts9': ':resources:images/cards/cardHearts9.png',
                   'cardClubs2': ':resources:images/cards/cardClubs2.png',
                   'cardSpades6': ':resources:images/cards/cardSpades6.png',
                   'cardHearts4': ':resources:images/cards/cardHearts4.png',
                   'cardDiamonds2': ':resources:images/cards/cardDiamonds2.png',
                   'cardDiamonds3': ':resources:images/cards/cardDiamonds3.png',
                   'cardHearts5': ':resources:images/cards/cardHearts5.png',
                   'cardSpadesA': ':resources:images/cards/cardSpadesA.png',
                   'cardSpades7': ':resources:images/cards/cardSpades7.png',
                   'cardClubsJ': ':resources:images/cards/cardClubsJ.png',
                   'cardSpades5': ':resources:images/cards/cardSpades5.png',
                   'cardHearts7': ':resources:images/cards/cardHearts7.png',
                   'cardHeartsA': ':resources:images/cards/cardHeartsA.png',
                   'cardDiamondsQ': ':resources:images/cards/cardDiamondsQ.png',
                   'cardHearts6': ':resources:images/cards/cardHearts6.png',
                   'cardSpades4': ':resources:images/cards/cardSpades4.png',
                   'cardClubsK': ':resources:images/cards/cardClubsK.png',
                   'cardClubs9': ':resources:images/cards/cardClubs9.png',
                   'cardSpadesQ': ':resources:images/cards/cardSpadesQ.png',
                   'cardHearts2': ':resources:images/cards/cardHearts2.png',
                   'cardDiamonds4': ':resources:images/cards/cardDiamonds4.png',
                   'cardDiamonds5': ':resources:images/cards/cardDiamonds5.png',
                   'cardHearts3': ':resources:images/cards/cardHearts3.png',
                   'cardClubs8': ':resources:images/cards/cardClubs8.png',
                   'cardSpades3': ':resources:images/cards/cardSpades3.png',
                   'cardDiamondsA': ':resources:images/cards/cardDiamondsA.png',
                   'cardDiamonds7': ':resources:images/cards/cardDiamonds7.png',
                   'cardDiamonds6': ':resources:images/cards/cardDiamonds6.png',
                   'cardHeartsQ': ':resources:images/cards/cardHeartsQ.png',
                   'cardSpades2': ':resources:images/cards/cardSpades2.png',
                   'cardHearts10': ':resources:images/cards/cardHearts10.png',
                   'cardBack_red4': ':resources:images/cards/cardBack_red4.png',
                   'cardBack_red5': ':resources:images/cards/cardBack_red5.png',
                   'cardBack_red1': ':resources:images/cards/cardBack_red1.png',
                   'cardJoker': ':resources:images/cards/cardJoker.png',
                   'cardBack_red2': ':resources:images/cards/cardBack_red2.png',
                   'cardBack_red3': ':resources:images/cards/cardBack_red3.png',
                   'alienBlue_climb2': ':resources:images/alien/alienBlue_climb2.png',
                   'alienBlue_walk2': ':resources:images/alien/alienBlue_walk2.png',
                   'alienBlue_climb1': ':resources:images/alien/alienBlue_climb1.png',
                   'alienBlue_walk1': ':resources:images/alien/alienBlue_walk1.png',
                   'alienBlue_front': ':resources:images/alien/alienBlue_front.png',
                   'alienBlue_jump': ':resources:images/alien/alienBlue_jump.png',
                   'number_sheet': ':resources:images/spritesheets/number_sheet.png',
                   'codepage_437': ':resources:images/spritesheets/codepage_437.png',
                   'tiles': ':resources:images/spritesheets/tiles.png',
                   'explosion': ':resources:images/spritesheets/explosion.png',
                   'snowCliff_left': ':resources:images/tiles/snowCliff_left.png',
                   'lava': ':resources:images/tiles/lava.png',
                   'grassHill_left': ':resources:images/tiles/grassHill_left.png',
                   'ladderMid': ':resources:images/items/ladderMid.png', 'bomb': ':resources:images/tiles/bomb.png',
                   'stoneCliffAlt_left': ':resources:images/tiles/stoneCliffAlt_left.png',
                   'sandHalf_right': ':resources:images/tiles/sandHalf_right.png',
                   'grassHill_right': ':resources:images/tiles/grassHill_right.png',
                   'planetCorner_left': ':resources:images/tiles/planetCorner_left.png',
                   'dirtCliff_left': ':resources:images/tiles/dirtCliff_left.png',
                   'planetHill_left': ':resources:images/tiles/planetHill_left.png',
                   'bridgeA': ':resources:images/tiles/bridgeA.png',
                   'planetHalf_right': ':resources:images/tiles/planetHalf_right.png',
                   'stoneCliffAlt_right': ':resources:images/tiles/stoneCliffAlt_right.png',
                   'brickBrown': ':resources:images/tiles/brickBrown.png',
                   'planet': ':resources:images/tiles/planet.png', 'snowRight': ':resources:images/tiles/snowRight.png',
                   'planetHalf_mid': ':resources:images/tiles/planetHalf_mid.png',
                   'planetHalf_left': ':resources:images/tiles/planetHalf_left.png',
                   'snowHill_right': ':resources:images/tiles/snowHill_right.png',
                   'dirt': ':resources:images/tiles/dirt.png', 'bridgeB': ':resources:images/tiles/bridgeB.png',
                   'waterTop_low': ':resources:images/tiles/waterTop_low.png',
                   'dirtHill_right': ':resources:images/tiles/dirtHill_right.png',
                   'lavaTop_high': ':resources:images/tiles/lavaTop_high.png',
                   'grassCliffAlt_right': ':resources:images/tiles/grassCliffAlt_right.png',
                   'grassCliff_left': ':resources:images/tiles/grassCliff_left.png',
                   'grassHalf_left': ':resources:images/tiles/grassHalf_left.png',
                   'dirtCliff_right': ':resources:images/tiles/dirtCliff_right.png',
                   'sandCorner_right': ':resources:images/tiles/sandCorner_right.png',
                   'stoneMid': ':resources:images/tiles/stoneMid.png',
                   'stoneCorner_left': ':resources:images/tiles/stoneCorner_left.png',
                   'boxCrate_double': ':resources:images/tiles/boxCrate_double.png',
                   'snowCliff_right': ':resources:images/tiles/snowCliff_right.png',
                   'dirtHill_left': ':resources:images/tiles/dirtHill_left.png',
                   'grassCliff_right': ':resources:images/tiles/grassCliff_right.png',
                   'lockRed': ':resources:images/tiles/lockRed.png', 'boxCrate': ':resources:images/tiles/boxCrate.png',
                   'ladderTop': ':resources:images/items/ladderTop.png',
                   'grassCorner_right': ':resources:images/tiles/grassCorner_right.png',
                   'cactus': ':resources:images/tiles/cactus.png',
                   'sandHill_left': ':resources:images/tiles/sandHill_left.png',
                   'grassHalf_mid': ':resources:images/tiles/grassHalf_mid.png',
                   'stoneHalf_left': ':resources:images/tiles/stoneHalf_left.png',
                   'sandCenter': ':resources:images/tiles/sandCenter.png',
                   'brickGrey': ':resources:images/tiles/brickGrey.png', 'rock': ':resources:images/tiles/rock.png',
                   'sandHalf_mid': ':resources:images/tiles/sandHalf_mid.png',
                   'sandCorner_left': ':resources:images/tiles/sandCorner_left.png',
                   'snow': ':resources:images/tiles/snow.png',
                   'stoneHalf_right': ':resources:images/tiles/stoneHalf_right.png',
                   'sandHalf_left': ':resources:images/tiles/sandHalf_left.png',
                   'stoneHill_left': ':resources:images/tiles/stoneHill_left.png',
                   'sandRight': ':resources:images/tiles/sandRight.png',
                   'switchGreen_pressed': ':resources:images/tiles/switchGreen_pressed.png',
                   'switchRed_pressed': ':resources:images/tiles/switchRed_pressed.png',
                   'stoneCenter_rounded': ':resources:images/tiles/stoneCenter_rounded.png',
                   'switchRed': ':resources:images/tiles/switchRed.png',
                   'grassRight': ':resources:images/tiles/grassRight.png',
                   'dirtHalf_left': ':resources:images/tiles/dirtHalf_left.png',
                   'grassCenter_round': ':resources:images/tiles/grassCenter_round.png',
                   'snowCenter': ':resources:images/tiles/snowCenter.png',
                   'stoneHalf_mid': ':resources:images/tiles/stoneHalf_mid.png',
                   'planetCorner_right': ':resources:images/tiles/planetCorner_right.png',
                   'stoneCorner_right': ':resources:images/tiles/stoneCorner_right.png',
                   'mushroomRed': ':resources:images/tiles/mushroomRed.png',
                   'plantPurple': ':resources:images/tiles/plantPurple.png',
                   'planetRight': ':resources:images/tiles/planetRight.png',
                   'waterTop_high': ':resources:images/tiles/waterTop_high.png',
                   'grass': ':resources:images/tiles/grass.png',
                   'brickTextureWhite': ':resources:images/tiles/brickTextureWhite.png',
                   'stone': ':resources:images/tiles/stone.png',
                   'planetCliff_right': ':resources:images/tiles/planetCliff_right.png',
                   'grassHalf': ':resources:images/tiles/grassHalf.png',
                   'planetCenter_rounded': ':resources:images/tiles/planetCenter_rounded.png',
                   'stoneHalf': ':resources:images/tiles/stoneHalf.png',
                   'stoneCliff_left': ':resources:images/tiles/stoneCliff_left.png',
                   'planetCenter': ':resources:images/tiles/planetCenter.png',
                   'switchGreen': ':resources:images/tiles/switchGreen.png',
                   'planetHalf': ':resources:images/tiles/planetHalf.png',
                   'snowMid': ':resources:images/tiles/snowMid.png',
                   'snowCliffAlt_left': ':resources:images/tiles/snowCliffAlt_left.png',
                   'sandMid': ':resources:images/tiles/sandMid.png',
                   'doorClosed_top': ':resources:images/tiles/doorClosed_top.png',
                   'snowCorner_right': ':resources:images/tiles/snowCorner_right.png',
                   'grassCenter': ':resources:images/tiles/grassCenter.png',
                   'water': ':resources:images/tiles/water.png',
                   'snowCenter_rounded': ':resources:images/tiles/snowCenter_rounded.png',
                   'spikes': ':resources:images/tiles/spikes.png',
                   'dirtCenter_rounded': ':resources:images/tiles/dirtCenter_rounded.png',
                   'dirtCorner_left': ':resources:images/tiles/dirtCorner_left.png',
                   'stoneLeft': ':resources:images/tiles/stoneLeft.png',
                   'dirtCliffAlt_left': ':resources:images/tiles/dirtCliffAlt_left.png',
                   'dirtRight': ':resources:images/tiles/dirtRight.png',
                   'planetCliffAlt_left': ':resources:images/tiles/planetCliffAlt_left.png',
                   'grassLeft': ':resources:images/tiles/grassLeft.png',
                   'stoneHill_right': ':resources:images/tiles/stoneHill_right.png',
                   'sandCliffAlt_right': ':resources:images/tiles/sandCliffAlt_right.png',
                   'boxCrate_single': ':resources:images/tiles/boxCrate_single.png',
                   'stoneCenter': ':resources:images/tiles/stoneCenter.png',
                   'planetLeft': ':resources:images/tiles/planetLeft.png',
                   'sandCliffAlt_left': ':resources:images/tiles/sandCliffAlt_left.png',
                   'grass_sprout': ':resources:images/tiles/grass_sprout.png',
                   'leverRight': ':resources:images/tiles/leverRight.png',
                   'lockYellow': ':resources:images/tiles/lockYellow.png',
                   'snowCorner_left': ':resources:images/tiles/snowCorner_left.png',
                   'torch2': ':resources:images/tiles/torch2.png',
                   'grassHalf_right': ':resources:images/tiles/grassHalf_right.png',
                   'sandHill_right': ':resources:images/tiles/sandHill_right.png',
                   'torchOff': ':resources:images/tiles/torchOff.png',
                   'snowLeft': ':resources:images/tiles/snowLeft.png',
                   'planetMid': ':resources:images/tiles/planetMid.png',
                   'grassCorner_left': ':resources:images/tiles/grassCorner_left.png',
                   'leverLeft': ':resources:images/tiles/leverLeft.png',
                   'snow_pile': ':resources:images/tiles/snow_pile.png',
                   'grassCliffAlt_left': ':resources:images/tiles/grassCliffAlt_left.png',
                   'planetCliffAlt_right': ':resources:images/tiles/planetCliffAlt_right.png',
                   'leverMid': ':resources:images/tiles/leverMid.png',
                   'lavaTop_low': ':resources:images/tiles/lavaTop_low.png',
                   'stoneCliff_right': ':resources:images/tiles/stoneCliff_right.png',
                   'torch1': ':resources:images/tiles/torch1.png',
                   'dirtCorner_right': ':resources:images/tiles/dirtCorner_right.png',
                   'dirtCenter': ':resources:images/tiles/dirtCenter.png',
                   'sandHalf': ':resources:images/tiles/sandHalf.png',
                   'signExit': ':resources:images/tiles/signExit.png',
                   'grassMid': ':resources:images/tiles/grassMid.png',
                   'planetCliff_left': ':resources:images/tiles/planetCliff_left.png',
                   'snowHalf_left': ':resources:images/tiles/snowHalf_left.png',
                   'sand': ':resources:images/tiles/sand.png', 'dirtHalf': ':resources:images/tiles/dirtHalf.png',
                   'sandCliff_right': ':resources:images/tiles/sandCliff_right.png',
                   'signLeft': ':resources:images/tiles/signLeft.png',
                   'snowHalf': ':resources:images/tiles/snowHalf.png',
                   'sandCenter_rounded': ':resources:images/tiles/sandCenter_rounded.png',
                   'dirtHalf_right': ':resources:images/tiles/dirtHalf_right.png',
                   'bush': ':resources:images/tiles/bush.png', 'stoneRight': ':resources:images/tiles/stoneRight.png',
                   'sandCliff_left': ':resources:images/tiles/sandCliff_left.png',
                   'dirtCliffAlt_right': ':resources:images/tiles/dirtCliffAlt_right.png',
                   'snowHill_left': ':resources:images/tiles/snowHill_left.png',
                   'sandLeft': ':resources:images/tiles/sandLeft.png',
                   'snowHalf_mid': ':resources:images/tiles/snowHalf_mid.png',
                   'dirtMid': ':resources:images/tiles/dirtMid.png',
                   'snowCliffAlt_right': ':resources:images/tiles/snowCliffAlt_right.png',
                   'planetHill_right': ':resources:images/tiles/planetHill_right.png',
                   'signRight': ':resources:images/tiles/signRight.png',
                   'dirtLeft': ':resources:images/tiles/dirtLeft.png',
                   'dirtHalf_mid': ':resources:images/tiles/dirtHalf_mid.png',
                   'snowHalf_right': ':resources:images/tiles/snowHalf_right.png',
                   'doorClosed_mid': ':resources:images/tiles/doorClosed_mid.png',
                   'instructions_1': ':resources:images/backgrounds/instructions_1.png',
                   'stars': ':resources:images/backgrounds/stars.png',
                   'instructions_0': ':resources:images/backgrounds/instructions_0.png',
                   'xy_square': ':resources:images/test_textures/xy_square.png',
                   'test_texture': ':resources:images/test_textures/test_texture.png',
                   'tank_sand': ':resources:images/topdown_tanks/tank_sand.png',
                   'tileGrass_transitionS': ':resources:images/topdown_tanks/tileGrass_transitionS.png',
                   'tileSand_roadCornerUR': ':resources:images/topdown_tanks/tileSand_roadCornerUR.png',
                   'tileGrass_roadTransitionN': ':resources:images/topdown_tanks/tileGrass_roadTransitionN.png',
                   'tank_green': ':resources:images/topdown_tanks/tank_green.png',
                   'tankBody_dark_outline': ':resources:images/topdown_tanks/tankBody_dark_outline.png',
                   'tileGrass_transitionE': ':resources:images/topdown_tanks/tileGrass_transitionE.png',
                   'tankBody_darkLarge_outline': ':resources:images/topdown_tanks/tankBody_darkLarge_outline.png',
                   'tileGrass_roadSplitE': ':resources:images/topdown_tanks/tileGrass_roadSplitE.png',
                   'tracksSmall': ':resources:images/topdown_tanks/tracksSmall.png',
                   'tileSand_roadCornerLR': ':resources:images/topdown_tanks/tileSand_roadCornerLR.png',
                   'tileGrass_roadSplitS': ':resources:images/topdown_tanks/tileGrass_roadSplitS.png',
                   'tankGreen_barrel1_outline': ':resources:images/topdown_tanks/tankGreen_barrel1_outline.png',
                   'tileGrass_roadTransitionE_dirt': ':resources:images/topdown_tanks/tileGrass_roadTransitionE_dirt.png',
                   'tankBody_huge_outline': ':resources:images/topdown_tanks/tankBody_huge_outline.png',
                   'tileGrass_roadSplitW': ':resources:images/topdown_tanks/tileGrass_roadSplitW.png',
                   'tankBlue_barrel1': ':resources:images/topdown_tanks/tankBlue_barrel1.png',
                   'tileSand_roadEast': ':resources:images/topdown_tanks/tileSand_roadEast.png',
                   'tracksLarge': ':resources:images/topdown_tanks/tracksLarge.png',
                   'tankDark_barrel3_outline': ':resources:images/topdown_tanks/tankDark_barrel3_outline.png',
                   'tankBlue_barrel2': ':resources:images/topdown_tanks/tankBlue_barrel2.png',
                   'tileGrass_roadTransitionN_dirt': ':resources:images/topdown_tanks/tileGrass_roadTransitionN_dirt.png',
                   'tankBody_green_outline': ':resources:images/topdown_tanks/tankBody_green_outline.png',
                   'tankBody_sand_outline': ':resources:images/topdown_tanks/tankBody_sand_outline.png',
                   'tankBlue_barrel3': ':resources:images/topdown_tanks/tankBlue_barrel3.png',
                   'tankBody_dark': ':resources:images/topdown_tanks/tankBody_dark.png',
                   'tileGrass_transitionW': ':resources:images/topdown_tanks/tileGrass_transitionW.png',
                   'tileSand_roadSplitE': ':resources:images/topdown_tanks/tileSand_roadSplitE.png',
                   'tankSand_barrel3_outline': ':resources:images/topdown_tanks/tankSand_barrel3_outline.png',
                   'tankBlue_barrel3_outline': ':resources:images/topdown_tanks/tankBlue_barrel3_outline.png',
                   'tileSand_roadSplitS': ':resources:images/topdown_tanks/tileSand_roadSplitS.png',
                   'tankBody_blue': ':resources:images/topdown_tanks/tankBody_blue.png',
                   'tileGrass_roadCrossingRound': ':resources:images/topdown_tanks/tileGrass_roadCrossingRound.png',
                   'tankRed_barrel3_outline': ':resources:images/topdown_tanks/tankRed_barrel3_outline.png',
                   'tankBody_red': ':resources:images/topdown_tanks/tankBody_red.png',
                   'tileGrass2': ':resources:images/topdown_tanks/tileGrass2.png',
                   'tileGrass_roadCornerLR': ':resources:images/topdown_tanks/tileGrass_roadCornerLR.png',
                   'tankGreen_barrel2_outline': ':resources:images/topdown_tanks/tankGreen_barrel2_outline.png',
                   'tankRed_barrel2': ':resources:images/topdown_tanks/tankRed_barrel2.png',
                   'tankBody_huge': ':resources:images/topdown_tanks/tankBody_huge.png',
                   'tankRed_barrel3': ':resources:images/topdown_tanks/tankRed_barrel3.png',
                   'tileGrass_roadEast': ':resources:images/topdown_tanks/tileGrass_roadEast.png',
                   'tileGrass_roadTransitionW_dirt': ':resources:images/topdown_tanks/tileGrass_roadTransitionW_dirt.png',
                   'tileGrass1': ':resources:images/topdown_tanks/tileGrass1.png',
                   'tileGrass_roadNorth': ':resources:images/topdown_tanks/tileGrass_roadNorth.png',
                   'tileSand_roadSplitW': ':resources:images/topdown_tanks/tileSand_roadSplitW.png',
                   'tankRed_barrel1': ':resources:images/topdown_tanks/tankRed_barrel1.png',
                   'tileGrass_roadCornerUR': ':resources:images/topdown_tanks/tileGrass_roadCornerUR.png',
                   'tankSand_barrel2': ':resources:images/topdown_tanks/tankSand_barrel2.png',
                   'tankSand_barrel1_outline': ':resources:images/topdown_tanks/tankSand_barrel1_outline.png',
                   'tankBody_blue_outline': ':resources:images/topdown_tanks/tankBody_blue_outline.png',
                   'tank_blue': ':resources:images/topdown_tanks/tank_blue.png',
                   'tankDark_barrel2_outline': ':resources:images/topdown_tanks/tankDark_barrel2_outline.png',
                   'tankBlue_barrel1_outline': ':resources:images/topdown_tanks/tankBlue_barrel1_outline.png',
                   'tankSand_barrel3': ':resources:images/topdown_tanks/tankSand_barrel3.png',
                   'tankSand_barrel1': ':resources:images/topdown_tanks/tankSand_barrel1.png',
                   'tankRed_barrel1_outline': ':resources:images/topdown_tanks/tankRed_barrel1_outline.png',
                   'tileSand_roadSplitN': ':resources:images/topdown_tanks/tileSand_roadSplitN.png',
                   'tank_red': ':resources:images/topdown_tanks/tank_red.png',
                   'tileSand_roadCrossing': ':resources:images/topdown_tanks/tileSand_roadCrossing.png',
                   'tileGrass_roadCornerLL': ':resources:images/topdown_tanks/tileGrass_roadCornerLL.png',
                   'tankBody_bigRed': ':resources:images/topdown_tanks/tankBody_bigRed.png',
                   'tileSand_roadNorth': ':resources:images/topdown_tanks/tileSand_roadNorth.png',
                   'tankDark_barrel1': ':resources:images/topdown_tanks/tankDark_barrel1.png',
                   'tankDark_barrel3': ':resources:images/topdown_tanks/tankDark_barrel3.png',
                   'tankBody_red_outline': ':resources:images/topdown_tanks/tankBody_red_outline.png',
                   'tileGrass_roadTransitionS_dirt': ':resources:images/topdown_tanks/tileGrass_roadTransitionS_dirt.png',
                   'tankDark_barrel2': ':resources:images/topdown_tanks/tankDark_barrel2.png',
                   'tankBody_darkLarge': ':resources:images/topdown_tanks/tankBody_darkLarge.png',
                   'tileGrass_roadCornerUL': ':resources:images/topdown_tanks/tileGrass_roadCornerUL.png',
                   'tankBody_sand': ':resources:images/topdown_tanks/tankBody_sand.png',
                   'tankGreen_barrel3': ':resources:images/topdown_tanks/tankGreen_barrel3.png',
                   'tankBody_green': ':resources:images/topdown_tanks/tankBody_green.png',
                   'tileSand_roadCornerUL': ':resources:images/topdown_tanks/tileSand_roadCornerUL.png',
                   'tileSand1': ':resources:images/topdown_tanks/tileSand1.png',
                   'tankGreen_barrel2': ':resources:images/topdown_tanks/tankGreen_barrel2.png',
                   'tileGrass_roadSplitN': ':resources:images/topdown_tanks/tileGrass_roadSplitN.png',
                   'tileGrass_transitionN': ':resources:images/topdown_tanks/tileGrass_transitionN.png',
                   'tileSand_roadCrossingRound': ':resources:images/topdown_tanks/tileSand_roadCrossingRound.png',
                   'treeBrown_small': ':resources:images/topdown_tanks/treeBrown_small.png',
                   'tileGrass_roadTransitionS': ':resources:images/topdown_tanks/tileGrass_roadTransitionS.png',
                   'tileSand_roadCornerLL': ':resources:images/topdown_tanks/tileSand_roadCornerLL.png',
                   'tileGrass_roadTransitionE': ':resources:images/topdown_tanks/tileGrass_roadTransitionE.png',
                   'tankGreen_barrel3_outline': ':resources:images/topdown_tanks/tankGreen_barrel3_outline.png',
                   'tracksDouble': ':resources:images/topdown_tanks/tracksDouble.png',
                   'treeGreen_large': ':resources:images/topdown_tanks/treeGreen_large.png',
                   'tileGrass_roadCrossing': ':resources:images/topdown_tanks/tileGrass_roadCrossing.png',
                   'tileSand2': ':resources:images/topdown_tanks/tileSand2.png',
                   'tankGreen_barrel1': ':resources:images/topdown_tanks/tankGreen_barrel1.png',
                   'treeGreen_small': ':resources:images/topdown_tanks/treeGreen_small.png',
                   'tileGrass_roadTransitionW': ':resources:images/topdown_tanks/tileGrass_roadTransitionW.png',
                   'tankRed_barrel2_outline': ':resources:images/topdown_tanks/tankRed_barrel2_outline.png',
                   'tankBody_bigRed_outline': ':resources:images/topdown_tanks/tankBody_bigRed_outline.png',
                   'treeBrown_large': ':resources:images/topdown_tanks/treeBrown_large.png',
                   'tankBlue_barrel2_outline': ':resources:images/topdown_tanks/tankBlue_barrel2_outline.png',
                   'tankDark_barrel1_outline': ':resources:images/topdown_tanks/tankDark_barrel1_outline.png',
                   'tank_dark': ':resources:images/topdown_tanks/tank_dark.png',
                   'tankSand_barrel2_outline': ':resources:images/topdown_tanks/tankSand_barrel2_outline.png',
                   'tableShortChairs_W': ':resources:images/isometric_dungeon/tableShortChairs_W.png',
                   'woodenCrates_W': ':resources:images/isometric_dungeon/woodenCrates_W.png',
                   'stone_W': ':resources:images/isometric_dungeon/stone_W.png',
                   'stoneWallCorner_S': ':resources:images/isometric_dungeon/stoneWallCorner_S.png',
                   'stoneWall_W': ':resources:images/isometric_dungeon/stoneWall_W.png',
                   'stoneTile_W': ':resources:images/isometric_dungeon/stoneTile_W.png',
                   'stoneWallCorner_E': ':resources:images/isometric_dungeon/stoneWallCorner_E.png',
                   'stoneTile_S': ':resources:images/isometric_dungeon/stoneTile_S.png',
                   'stoneSide_E': ':resources:images/isometric_dungeon/stoneSide_E.png',
                   'stoneWall_S': ':resources:images/isometric_dungeon/stoneWall_S.png',
                   'stoneWallCorner_W': ':resources:images/isometric_dungeon/stoneWallCorner_W.png',
                   'woodenSupportBeams_S': ':resources:images/isometric_dungeon/woodenSupportBeams_S.png',
                   'stone_S': ':resources:images/isometric_dungeon/stone_S.png',
                   'stoneWallAged_E': ':resources:images/isometric_dungeon/stoneWallAged_E.png',
                   'stoneWallAged_S': ':resources:images/isometric_dungeon/stoneWallAged_S.png',
                   'stone_E': ':resources:images/isometric_dungeon/stone_E.png',
                   'dirt_S': ':resources:images/isometric_dungeon/dirt_S.png',
                   'woodenSupportsBeam_S': ':resources:images/isometric_dungeon/woodenSupportsBeam_S.png',
                   'stoneMissingTiles_W': ':resources:images/isometric_dungeon/stoneMissingTiles_W.png',
                   'stoneMissingTiles_S': ':resources:images/isometric_dungeon/stoneMissingTiles_S.png',
                   'stoneUneven_N': ':resources:images/isometric_dungeon/stoneUneven_N.png',
                   'stoneMissingTiles_E': ':resources:images/isometric_dungeon/stoneMissingTiles_E.png',
                   'stoneUneven_W': ':resources:images/isometric_dungeon/stoneUneven_W.png',
                   'stoneWallArchway_S': ':resources:images/isometric_dungeon/stoneWallArchway_S.png',
                   'stoneWallGateClosed_E': ':resources:images/isometric_dungeon/stoneWallGateClosed_E.png',
                   'stoneWallGateClosed_S': ':resources:images/isometric_dungeon/stoneWallGateClosed_S.png',
                   'stoneWallColumn_E': ':resources:images/isometric_dungeon/stoneWallColumn_E.png',
                   'stoneMissingTiles_N': ':resources:images/isometric_dungeon/stoneMissingTiles_N.png',
                   'stoneUneven_E': ':resources:images/isometric_dungeon/stoneUneven_E.png',
                   'stoneUneven_S': ':resources:images/isometric_dungeon/stoneUneven_S.png',
                   'stoneWallCorner_N': ':resources:images/isometric_dungeon/stoneWallCorner_N.png',
                   'stoneLeft_N': ':resources:images/isometric_dungeon/stoneLeft_N.png',
                   'dirtTiles_S': ':resources:images/isometric_dungeon/dirtTiles_S.png',
                   'tableChairsBroken_S': ':resources:images/isometric_dungeon/tableChairsBroken_S.png',
                   'tableChairsBroken_E': ':resources:images/isometric_dungeon/tableChairsBroken_E.png',
                   'stone_N': ':resources:images/isometric_dungeon/stone_N.png',
                   'stoneSideUneven_N': ':resources:images/isometric_dungeon/stoneSideUneven_N.png',
                   'stoneWallGateOpen_E': ':resources:images/isometric_dungeon/stoneWallGateOpen_E.png',
                   'stoneTile_N': ':resources:images/isometric_dungeon/stoneTile_N.png',
                   'stoneWall_N': ':resources:images/isometric_dungeon/stoneWall_N.png',
                   'malePerson_walk4': ':resources:images/animated_characters/male_person/malePerson_walk4.png',
                   'malePerson_walk5': ':resources:images/animated_characters/male_person/malePerson_walk5.png',
                   'malePerson_walk7': ':resources:images/animated_characters/male_person/malePerson_walk7.png',
                   'malePerson_walk6': ':resources:images/animated_characters/male_person/malePerson_walk6.png',
                   'malePerson_walk2': ':resources:images/animated_characters/male_person/malePerson_walk2.png',
                   'malePerson_walk3': ':resources:images/animated_characters/male_person/malePerson_walk3.png',
                   'malePerson_walk1': ':resources:images/animated_characters/male_person/malePerson_walk1.png',
                   'malePerson_walk0': ':resources:images/animated_characters/male_person/malePerson_walk0.png',
                   'malePerson_climb0': ':resources:images/animated_characters/male_person/malePerson_climb0.png',
                   'malePerson_climb1': ':resources:images/animated_characters/male_person/malePerson_climb1.png',
                   'malePerson_jump': ':resources:images/animated_characters/male_person/malePerson_jump.png',
                   'malePerson_fall': ':resources:images/animated_characters/male_person/malePerson_fall.png',
                   'malePerson_idle': ':resources:images/animated_characters/male_person/malePerson_idle.png',
                   'zombie_jump': ':resources:images/animated_characters/zombie/zombie_jump.png',
                   'zombie_walk1': ':resources:images/animated_characters/zombie/zombie_walk1.png',
                   'zombie_walk0': ':resources:images/animated_characters/zombie/zombie_walk0.png',
                   'zombie_fall': ':resources:images/animated_characters/zombie/zombie_fall.png',
                   'zombie_climb1': ':resources:images/animated_characters/zombie/zombie_climb1.png',
                   'zombie_walk2': ':resources:images/animated_characters/zombie/zombie_walk2.png',
                   'zombie_idle': ':resources:images/animated_characters/zombie/zombie_idle.png',
                   'zombie_walk3': ':resources:images/animated_characters/zombie/zombie_walk3.png',
                   'zombie_climb0': ':resources:images/animated_characters/zombie/zombie_climb0.png',
                   'zombie_walk7': ':resources:images/animated_characters/zombie/zombie_walk7.png',
                   'zombie_walk6': ':resources:images/animated_characters/zombie/zombie_walk6.png',
                   'zombie_walk4': ':resources:images/animated_characters/zombie/zombie_walk4.png',
                   'zombie_walk5': ':resources:images/animated_characters/zombie/zombie_walk5.png',
                   'femaleAdventurer_walk6': ':resources:images/animated_characters/female_adventurer/femaleAdventurer_walk6.png',
                   'femaleAdventurer_walk7': ':resources:images/animated_characters/female_adventurer/femaleAdventurer_walk7.png',
                   'femaleAdventurer_walk5': ':resources:images/animated_characters/female_adventurer/femaleAdventurer_walk5.png',
                   'femaleAdventurer_walk4': ':resources:images/animated_characters/female_adventurer/femaleAdventurer_walk4.png',
                   'femaleAdventurer_walk0': ':resources:images/animated_characters/female_adventurer/femaleAdventurer_walk0.png',
                   'femaleAdventurer_walk1': ':resources:images/animated_characters/female_adventurer/femaleAdventurer_walk1.png',
                   'femaleAdventurer_walk3': ':resources:images/animated_characters/female_adventurer/femaleAdventurer_walk3.png',
                   'femaleAdventurer_walk2': ':resources:images/animated_characters/female_adventurer/femaleAdventurer_walk2.png',
                   'femaleAdventurer_climb1': ':resources:images/animated_characters/female_adventurer/femaleAdventurer_climb1.png',
                   'femaleAdventurer_climb0': ':resources:images/animated_characters/female_adventurer/femaleAdventurer_climb0.png',
                   'femaleAdventurer_jump': ':resources:images/animated_characters/female_adventurer/femaleAdventurer_jump.png',
                   'femaleAdventurer_fall': ':resources:images/animated_characters/female_adventurer/femaleAdventurer_fall.png',
                   'femaleAdventurer_idle': ':resources:images/animated_characters/female_adventurer/femaleAdventurer_idle.png',
                   'maleAdventurer_fall': ':resources:images/animated_characters/male_adventurer/maleAdventurer_fall.png',
                   'maleAdventurer_idle': ':resources:images/animated_characters/male_adventurer/maleAdventurer_idle.png',
                   'maleAdventurer_walk1': ':resources:images/animated_characters/male_adventurer/maleAdventurer_walk1.png',
                   'maleAdventurer_walk0': ':resources:images/animated_characters/male_adventurer/maleAdventurer_walk0.png',
                   'maleAdventurer_jump': ':resources:images/animated_characters/male_adventurer/maleAdventurer_jump.png',
                   'maleAdventurer_walk2': ':resources:images/animated_characters/male_adventurer/maleAdventurer_walk2.png',
                   'maleAdventurer_walk3': ':resources:images/animated_characters/male_adventurer/maleAdventurer_walk3.png',
                   'maleAdventurer_walk7': ':resources:images/animated_characters/male_adventurer/maleAdventurer_walk7.png',
                   'maleAdventurer_walk6': ':resources:images/animated_characters/male_adventurer/maleAdventurer_walk6.png',
                   'maleAdventurer_walk4': ':resources:images/animated_characters/male_adventurer/maleAdventurer_walk4.png',
                   'maleAdventurer_walk5': ':resources:images/animated_characters/male_adventurer/maleAdventurer_walk5.png',
                   'maleAdventurer_climb1': ':resources:images/animated_characters/male_adventurer/maleAdventurer_climb1.png',
                   'maleAdventurer_climb0': ':resources:images/animated_characters/male_adventurer/maleAdventurer_climb0.png',
                   'femalePerson_climb1': ':resources:images/animated_characters/female_person/femalePerson_climb1.png',
                   'femalePerson_climb0': ':resources:images/animated_characters/female_person/femalePerson_climb0.png',
                   'femalePerson_walk5': ':resources:images/animated_characters/female_person/femalePerson_walk5.png',
                   'femalePerson_walk4': ':resources:images/animated_characters/female_person/femalePerson_walk4.png',
                   'femalePerson_walk6': ':resources:images/animated_characters/female_person/femalePerson_walk6.png',
                   'femalePerson_walk7': ':resources:images/animated_characters/female_person/femalePerson_walk7.png',
                   'femalePerson_walk3': ':resources:images/animated_characters/female_person/femalePerson_walk3.png',
                   'femalePerson_walk2': ':resources:images/animated_characters/female_person/femalePerson_walk2.png',
                   'femalePerson_walk0': ':resources:images/animated_characters/female_person/femalePerson_walk0.png',
                   'femalePerson_walk1': ':resources:images/animated_characters/female_person/femalePerson_walk1.png',
                   'femalePerson_jump': ':resources:images/animated_characters/female_person/femalePerson_jump.png',
                   'femalePerson_fall': ':resources:images/animated_characters/female_person/femalePerson_fall.png',
                   'femalePerson_idle': ':resources:images/animated_characters/female_person/femalePerson_idle.png',
                   'robot_idle': ':resources:images/animated_characters/robot/robot_idle.png',
                   'robot_fall': ':resources:images/animated_characters/robot/robot_fall.png',
                   'robot_walk7': ':resources:images/animated_characters/robot/robot_walk7.png',
                   'robot_walk6': ':resources:images/animated_characters/robot/robot_walk6.png',
                   'robot_walk4': ':resources:images/animated_characters/robot/robot_walk4.png',
                   'robot_walk5': ':resources:images/animated_characters/robot/robot_walk5.png',
                   'robot_walk1': ':resources:images/animated_characters/robot/robot_walk1.png',
                   'robot_jump': ':resources:images/animated_characters/robot/robot_jump.png',
                   'robot_walk0': ':resources:images/animated_characters/robot/robot_walk0.png',
                   'robot_walk2': ':resources:images/animated_characters/robot/robot_walk2.png',
                   'robot_walk3': ':resources:images/animated_characters/robot/robot_walk3.png',
                   'robot_climb1': ':resources:images/animated_characters/robot/robot_climb1.png',
                   'robot_climb0': ':resources:images/animated_characters/robot/robot_climb0.png',
                   'flagRed2': ':resources:images/items/flagRed2.png',
                   'coinSilver': ':resources:images/items/coinSilver.png',
                   'flagRed1': ':resources:images/items/flagRed1.png',
                   'keyGreen': ':resources:images/items/keyGreen.png',
                   'gemYellow': ':resources:images/items/gemYellow.png',
                   'flagGreen_down': ':resources:images/items/flagGreen_down.png',
                   'flagYellow_down': ':resources:images/items/flagYellow_down.png',
                   'flagYellow2': ':resources:images/items/flagYellow2.png',
                   'coinGold_lr': ':resources:images/items/coinGold_lr.png',
                   'flagYellow1': ':resources:images/items/flagYellow1.png',
                   'coinSilver_test': ':resources:images/items/coinSilver_test.png',
                   'coinGold_ur': ':resources:images/items/coinGold_ur.png',
                   'keyYellow': ':resources:images/items/keyYellow.png', 'gold_2': ':resources:images/items/gold_2.png',
                   'coinGold_ll': ':resources:images/items/coinGold_ll.png',
                   'coinGold': ':resources:images/items/coinGold.png', 'keyRed': ':resources:images/items/keyRed.png',
                   'gemGreen': ':resources:images/items/gemGreen.png', 'gold_3': ':resources:images/items/gold_3.png',
                   'gold_1': ':resources:images/items/gold_1.png',
                   'coinGold_ul': ':resources:images/items/coinGold_ul.png',
                   'gold_4': ':resources:images/items/gold_4.png', 'keyBlue': ':resources:images/items/keyBlue.png',
                   'star': ':resources:images/items/star.png', 'coinBronze': ':resources:images/items/coinBronze.png',
                   'gemBlue': ':resources:images/items/gemBlue.png',
                   'flagGreen2': ':resources:images/items/flagGreen2.png',
                   'flagRed_down': ':resources:images/items/flagRed_down.png',
                   'flagGreen1': ':resources:images/items/flagGreen1.png',
                   'gemRed': ':resources:images/items/gemRed.png',
                   'pool_cue_ball': ':resources:images/pinball/pool_cue_ball.png',
                   'bumper': ':resources:images/pinball/bumper.png', 'saw': ':resources:images/enemies/saw.png',
                   'sawHalf': ':resources:images/enemies/sawHalf.png',
                   'slimeBlue': ':resources:images/enemies/slimeBlue.png',
                   'frog_move': ':resources:images/enemies/frog_move.png', 'fly': ':resources:images/enemies/fly.png',
                   'slimePurple': ':resources:images/enemies/slimePurple.png',
                   'slimeGreen': ':resources:images/enemies/slimeGreen.png',
                   'wormGreen': ':resources:images/enemies/wormGreen.png',
                   'ladybug': ':resources:images/enemies/ladybug.png',
                   'wormGreen_move': ':resources:images/enemies/wormGreen_move.png',
                   'bee': ':resources:images/enemies/bee.png', 'slimeBlock': ':resources:images/enemies/slimeBlock.png',
                   'fishPink': ':resources:images/enemies/fishPink.png', 'mouse': ':resources:images/enemies/mouse.png',
                   'wormGreen_dead': ':resources:images/enemies/wormGreen_dead.png',
                   'frog': ':resources:images/enemies/frog.png',
                   'slimeBlue_move': ':resources:images/enemies/slimeBlue_move.png',
                   'fishGreen': ':resources:images/enemies/fishGreen.png',
                   'wormPink': ':resources:images/enemies/wormPink.png'}
